/*****************************************************************************************
 Copyright (c) 2002-2004 The UbixOS Project
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are
 permitted provided that the following conditions are met:

 Redistributions of source code must retain the above copyright notice, this list of
 conditions, the following disclaimer and the list of authors.  Redistributions in binary
 form must reproduce the above copyright notice, this list of conditions, the following
 disclaimer and the list of authors in the documentation and/or other materials provided
 with the distribution. Neither the name of the UbixOS Project nor the names of its
 contributors may be used to endorse or promote products derived from this software
 without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 $Id$

*****************************************************************************************/

#include <ubixos/tty.h>
#include <ubixos/kpanic.h>
#include <ubixos/spinlock.h>
#include <lib/kprintf.h>
#include <lib/kmalloc.h>
#include <string.h>

static tty_term *terms       = 0x0;
static uInt16    tty_current = 0x0;
static spinLock_t tty_spinLock = SPIN_LOCK_INITIALIZER;

int tty_init() {
  int i = 0x0;

  /* Allocate memory for terminals */

  terms = (tty_term *)kmalloc(sizeof(tty_term)*TTY_MAX_TERMS);
  if (terms == 0x0)
    kpanic("tty_init: Failed to allocate memory\n");

  for (i = 0;i < TTY_MAX_TERMS;i++) {
    terms[i].tty_buffer = (char *)kmalloc(80*60*2);
    if (terms[i].tty_buffer == 0x0)
      kpanic("tty_init: Failed to allocate buffer memory\n"); 
    terms[i].tty_pointer = terms[i].tty_buffer;
    terms[i].tty_x       = 0x0;
    terms[i].tty_y       = 0x0;
    terms[i].current     = 0x0;
    terms[i].tty_colour  = 0x0A + i;
    }
  terms[0].tty_pointer = (char *)0xB8000;
  terms[0].current     = 0x1;
  kprintf("tty0 - Initialized\n");

  return(0x0);
  }

int tty_change(uInt16 tty) {
  memcpy(terms[tty_current].tty_buffer,(char *)0xB8000,(80*60*2));
  memcpy((char *)0xB8000,terms[tty].tty_buffer,(80*60*2));
  terms[tty_current].tty_pointer = terms[tty_current].tty_buffer;
  terms[tty_current].current = 0x0;
  
  terms[tty].tty_pointer = (char *)0xB8000;
  terms[tty].current     = 0x1;
  tty_current = tty;
  return(0x0);
  }
   
int tty_print(char *string,tty_term *term) {
  unsigned int    bufferOffset = 0x0, character = 0x0, i = 0x0;
  spinLock(&tty_spinLock);
  
  /* We Need To Get The Y Position */
  bufferOffset = term->tty_y;
  bufferOffset <<= 8;
  
  /* Then We Need To Add The X Position */
  bufferOffset += term->tty_x;
  bufferOffset <<= 1;

  while ((character = *string++)) {
    switch (character) {
    case '\n':
      bufferOffset = (bufferOffset / 160) * 160 + 160;
      break;
    default:
      term->tty_pointer[bufferOffset++] = character;
      term->tty_pointer[bufferOffset++] = term->tty_colour;
      break;
    }				/* switch */
    /* Check To See If We Are Out Of Bounds */
    if (bufferOffset >= 160 * 25) {
      for (i = 0; i < 160 * 24; i++) {
        term->tty_pointer[i] = term->tty_pointer[i + 160];
        }
      for (i = 0; i < 80; i++) {
        term->tty_pointer[(160 * 24) + (i * 2)] = 0x20;
        term->tty_pointer[(160 * 24) + (i * 2) + 1] = term->tty_colour;
        }
      bufferOffset -= 160;
      }
    }	
  bufferOffset >>= 1;		/* Set the new cursor position  */
  term->tty_x = (bufferOffset & 0xFF);
  term->tty_y = (bufferOffset >> 8);
  spinUnlock(&tty_spinLock);

  return(0x0);
  }
  
tty_term *tty_find(uInt16 tty) {
  return(&terms[tty]);
  }

/***
 $Log$
 Revision 1.2  2004/08/04 08:17:57  reddawg
 tty: we have primative ttys try f1-f5 so it is easier to use and debug
      ubixos

 Revision 1.1  2004/08/03 21:44:24  reddawg
 ttys

 END
 ***/

